
package fr.gouv.finances.dgfip.xemelios.controls.sortiesdirectesstock;

/*
 * Copyright 
 *   2010 axYus - www.axyus.com
 *   2010 C ARIOUAT - assia.ariouat@axyus.com
 * 
 * This file is part of XEMELIOS.
 * 
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



import java.util.Hashtable;
import java.util.Stack;
import java.util.Vector;
import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import fr.gouv.finances.cp.xemelios.controls.AbstractUnitControl;
import fr.gouv.finances.cp.xemelios.controls.Anomalie;
import fr.gouv.finances.cp.xemelios.controls.IdGenerator;
import fr.gouv.finances.cp.xemelios.controls.Node;

/**
 * Si CODE_MVT = ‘702’,  MOTIF_MVT est valorisé.
Si CODE_MVT = ‘201’, GR_GI_SLIP_NO est valorisé. 
 * @author Assia ARIOUAT
 */

public class M169 extends AbstractUnitControl {
    public static final String CTRL_ID = "CTL-M169" ;
    public static final transient String RESET_COUNTER_PATH = "FEN0071A/SDS/";
    public static final transient String CHEMIN_ENTETE_IDAE = "FEN0071A/SDS/ENTETE/ID_AE/";
    public static final transient String CHEMIN_ENTETE= "FEN0071A/SDS/ENTETE/";
    public static final transient String CHEMIN_GR_GI_SLIP_NO= "FEN0071A/SDS/ENTETE/GR_GI_SLIP_NO/";
    public static final transient String CHEMIN_CODE_MVT= "FEN0071A/SDS/ENTETE/CODE_MVT/";
    public static final transient String CHEMIN_MOTIF_MVT= "FEN0071A/SDS/ENTETE/MOTIF_MVT/";
 

    public static final transient String RETURN_ANOMALIES_PATH = RESET_COUNTER_PATH;

    private static final Logger logger = Logger.getLogger(M169.class);

    // pour stocker tous les paramètres d'execution des controles
    private Hashtable<String,Object> hParams;

    private String ID_SDS = null;
	private String ID_SDS_Unique = "";
    private String  motif_mvt = "";
    private String gr_gi_slp_no = "";
  	private String numLigneTexte = "";
	private String cod_mvt = "";
	private String entete_Nod = "";


    //pour le message d'erreurs
    private static final String MSG_IDPOSTE= "#IDPOSTE#";
    private static final String MSG_ID_LIG = "#ID_LIG#";
       
    // pour récupérer le texte des balises
    private Stack<StringBuffer> chars = new Stack<StringBuffer>();

    // pour stocker les anomalies que l'on génère
    Vector<Anomalie> anomalies = null;

    public void endDocument() throws SAXException { }

    public void startElement(String uri, String localName, String qName, Attributes atts, String xpath) throws SAXException {
    	
    	 if(xpath.equals(CHEMIN_ENTETE)){
    		 entete_Nod = atts.getValue("ano:node-id");
    	 
    	 }
    	
    	if(xpath.equals(RESET_COUNTER_PATH)) {           
            anomalies = new Vector<Anomalie>();
            ID_SDS =gr_gi_slp_no=cod_mvt= "";            
            ID_SDS_Unique = atts.getValue("ano:unique-id");  
            motif_mvt ="";  
        } 
        chars.push(new StringBuffer());
    }

    public Vector<Anomalie> endElement(String uri, String localName, String qName, String xpath) throws SAXException {
    	
    		if(xpath.equals(CHEMIN_ENTETE_IDAE)) {
    			ID_SDS = chars.peek().toString();
    			}
    		
    		
    		 else if(xpath.equals(CHEMIN_MOTIF_MVT)) {
    			 
    			 motif_mvt=chars.peek().toString();
    			 }
    		
    		 else if(xpath.equals(CHEMIN_CODE_MVT)){
    			 cod_mvt= chars.peek().toString();

    		      }
    		 else if(xpath.equals(CHEMIN_GR_GI_SLIP_NO)){
    			 gr_gi_slp_no= chars.peek().toString();

    		      }
    		 else if(xpath.equals(RESET_COUNTER_PATH)){
	          
    		  if ((cod_mvt.equals("702")&& (motif_mvt.length()==0))||(cod_mvt.equals("201")&& (gr_gi_slp_no.length()==0)))
    		      		  
    		  {

      			String anoId = IdGenerator.nextId();
                  Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
                  xslParams.put("anoId", anoId);
                  xslParams.put("presentation","src");
                  String libelleLien = "SDS_ID "+ID_SDS;
                  String path = "@ano:unique-id='" + ID_SDS_Unique + "'";
                  // on reconstitue le message
                  String msg = (numLigneTexte.length()>0?"Ligne n°"+numLigneTexte+" : ":"");
      			msg += getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
      			msg = msg.replace("#SDS_ID#", ID_SDS);
                  
                        
                  Anomalie ano = new Anomalie(anoId,
                          getDocumentModel().getControlById(CTRL_ID),
                          getDocumentModel().getDocumentId(),
                          "FEN0071A",
                          "SDS",
                          ID_SDS,
                          localName,  // l'élément en anomalie est bien EDS
                          libelleLien,
                          msg,
                          getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                          getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                          path,
                          xslParams);

	                   	ano.addNode(new Node(entete_Nod));
	                    anomalies.add(ano);  
	                    chars.pop();
	                    return anomalies;
    		      }}
    		  else {  
    			  chars.pop();
    		  }
		      return null;}
		           
           
    
       

    public void characters(char[] ch, int start, int length, String xpath) throws SAXException {
        // on met les caractères lus dans la pile
        chars.peek().append(ch, start, length);
    }

    public void ignorableWhitespace(char[] ch, int start, int length, String xpath) throws SAXException { }

    public void processingInstruction(String target, String data, String xpath) throws SAXException { }

    public void skippedEntity(String name, String xpath) throws SAXException { }

    public void setParameters(Hashtable<String, Object> params) {
        this.hParams=params;
    }

    public void setDocumentLocator(Locator locator) { }

    public void startDocument() throws SAXException { }

    public void startPrefixMapping(String prefix, String uri, String xpath) throws SAXException { }

    public void endPrefixMapping(String prefix, String xpath) throws SAXException { }
}
